/**
 * Clock Countdown
 * 
 * @file       countdown.js
 * @brief      Countdown adapted from Dokuwiki plugin
 * @license    Boost License
 * @author     Luis Machuca B. <luis.machuca [at] gulix.cl>
 * @version    1.0
 * 
 *  This file contains the 
 *  plain (text) visual component for the clock plugin.
 */

function dhclock_ (obj, TargetDate) {
  this.obj  = obj;
  //this.ref  = oname;
  //this.target = TargetDate;
  this.tT   = new Date(TargetDate);
  this.dd   = 0;
  this.hh   = 0;
  this.mm   = 0;
  this.ss   = 0;

  this.tick = dhclock_tick;
  }

/**
 * This function makes the clock "tick" 
 */
function dhclock_tick () {

  // tick the clock
  var cT  = new Date();
  var rem = (this.tT - cT);
  rem     = parseInt(Math.floor(rem.valueOf()) / 1000);

  // rem es la diferencia. Repartir en dias, horas, minutos, segundos
  this.dd = Math.floor(rem / 86400);
  this.hh = Math.floor(rem / 3600) % 24;
  this.mm = Math.floor(rem / 60) % 60;
  this.ss = Math.floor(rem % 60);

  //setTimeout(this.obj + ".tick()", 330);
  }

// the DOM object used for visualization
var dhClockTimer;

/**
 * @fn    dwclock_rerun
 * @brief Ticks the clock and updates the visual
 */
function _update () {

  // use the Date functions
  // to get the current time (hh:mm:ss)
  dhClockTimer.tick();
  var LD= (dhClockTimer.dd);
  var LH= dhClockTimer.hh;
  var LM= dhClockTimer.mm;
  var LS= dhClockTimer.ss;

  // reformat the values as strings with 2 digits
  var SD= LD;
  var SH= ((LH<10) ? "0" : "") + LH;
  var SM= ((LM<10) ? "0" : "") + LM;
  var SS= ((LS<10) ? "0" : "") + LS;

  ClockDOMObject.innerHTML= SD + '+ ' + SH + ':' + SM + ':' + SS;
  //clock_Pieces[6].innerHTML= msg;

  setTimeout(_update, 490);
}

/**
 * @fn    dwclock_init
 * @brief Ticks the clock and updates the visual
 */
function countdown24_init() {
  // the target date
  //var TargetDate = "01/07/2010";
  if (TargetDate == undefined ) throw new Error ('No ClockDomObject');
  ClockDOMObject= document.getElementById(ClockDOMName);
  if (dhClockTimer == undefined ) dhClockTimer= new dhclock_ ("dhClockTimer", TargetDate);

  if (ClockDOMObject) {
    // at this point, dwClockDOMObject can be directly
    // modified through the .innerHTML method.
    setTimeout(_update, 1000);
    }
  else { 
    // clock init failed
    errmsg= clock_Err + "init failed!";
    errmsg= errmsg+"\n(can't find container: "+jsclock_id+")";
    throw new Error(errmsg);
    }
}

